SUBROUTINE boundary_cond(dof,bc,gchi,connec,nxe,nye,nodes,void,frdof)
!
! This function defines the boundary conditions to be applied.
!
 IMPLICIT NONE
 INTEGER,PARAMETER::iwp=SELECTED_REAL_KIND(15)
 REAL(iwp),ALLOCATABLE,INTENT(IN)::gchi(:,:),void(:,:),nodes(:,:)
 INTEGER,ALLOCATABLE,INTENT(IN)::connec(:,:)
 INTEGER,INTENT(IN)::dof,bc,nxe,nye
 INTEGER,ALLOCATABLE,INTENT(OUT)::frdof(:)
 REAL(iwp)::hori(2),vert(2)
 INTEGER::i,j,k,node,counter!,ind
 INTEGER,ALLOCATABLE::fxdof(:),temp(:),alldof(:)
 !CHARACTER(LEN=15)::element
 !
 ALLOCATE(fxdof((nxe+1)*(nye+1)))
 fxdof=0
 !
 k=1
 IF (bc==1) THEN
	DO i=1,nxe+1
		IF (i==1) THEN
			fxdof(k:k+1)=(/2*i-1,2*i/)
		ELSE
			fxdof(k)=2*i
			k=k+1
		END IF
	END DO
 ELSE IF (bc==2) THEN
	fxdof=(/2*(nxe+1)-1,2*(nxe+1),2*(nxe+1)*(nye+1)-1/)
 ELSE IF (bc==3) THEN
	node=1
	DO i=1,nye+1
		fxdof(k)=2*node-1
		k=k+1
		node=node+nxe+1
	END DO
	node=nxe+1
	DO i=1,nye+1
		IF (i==1) THEN
			fxdof(k:k+1)=(/2*node-1,2*node/)
			k=k+2
		ELSE
			fxdof(k)=2*node-1
			k=k+1
		END IF
		node=node+nxe+1
	END DO
 ELSE IF (bc==4) THEN
	vert=(/2*(nxe+1)*(nye/2)+2,2*(nxe+1)*(nye/2+1)/)
	hori=(/2*(nxe+1)*(nye/2)+1,0/)
	fxdof(1)=hori(1)
	fxdof(2:3)=vert
	k=k+3
 ELSE IF (bc==5) THEN
    node=1
	DO i=1,nye+1
		fxdof(k)=2*node-1
		k=k+1
		node=node+nxe+1
	END DO
	DO i=1,nxe+1
		fxdof(k)=2*i
		k=k+1
	END DO
 ELSE IF (bc==6) THEN
	vert=(/2*(nxe+1)*(nye/2)+1,2*(nxe+1)*(nye/2+1)/)
	hori=(/2*(nxe/2+1)-1,2*(nxe+1)*nye+nxe+1/)
	fxdof(1:2)=hori
	fxdof(3:4)=vert
	k=k+4
 END IF
 
 IF (SIZE(void)/=3) THEN
	dmin=zero
	compa='le'
	CALL find_loc(gchi,compa,dmin,vdnd)
	nelem=1
	lszero=connec(nelem,2:5)
	DO iy=1,nye
		DO ix=1,nxe
			chi=gchi(connec(nelem,2:5))
			IF (MAXVAL(chi)*MINVAL(chi)<0) THEN
			    lsadd=connec(nelem,2:5)
				CALL bmatrix_assemble(lszero,lsadd,lszero)
			END IF
			nelem=nelem+1
		END DO
	END DO
	CALL set_diff(voidnd,lszero,voidbc)
	!
	ind=(/2,4,6,8,10,12,14,16,18,20,22,24,26,28,30/)
	voidenr=nodes(voidbc(1),ind)
	DO i=2,SIZE(voidbc)
		CALL bmatrix_assemble(voidenr,nodes(voidbc(i),ind)) 
	END DO
	CALL unique1(voidenr)
	!
	IF (holeenr(1)==0) THEN
		ALLOCATE(temp(SIZE(voidenr)-1))
		temp=voidenr(2:SIZE(voidenr))
		DEALLOCATE(voidenr)
		ALLOCATE(voidenr(SIZE(temp)))
		voidenr=temp
		DEALLOCATE(temp)
	END IF
	CALL bmatrix_assemble(voidbc,voidenr)
	fxdof(ind:(ind+2*SIZE(holebc)-1))=(/2*holebc-1,2*holebc/)
 END IF

 shorten: DO i=1,dof
	IF (fxdof(i)==0) THEN
	    ALLOCATE(temp(i-1))
		temp=fxdof(1:i-1)
		DEALLOCATE(fxdof)
		ALLOCATE(fxdof(SIZE(temp)))
		fxdof=temp
		DEALLOCATE(temp)
		EXIT shorten
	END IF
 END DO shorten
 !
 ALLOCATE(alldof(dof),frdof(dof))
 alldof=0.0
 frdof=0.0
 DO i=1,dof
	alldof(i)=i
	frdof(i)=i
 END DO
 !
 DO i=1,dof
	IF (ANY(fxdof==alldof(i))) THEN
		frdof(i)=0.0
	END IF
 END DO
 !
 CALL unique1(frdof)
 ALLOCATE(temp(SIZE(frdof)-1))
 temp=frdof(2:SIZE(frdof))
 DEALLOCATE(frdof)
 ALLOCATE(frdof(SIZE(temp)))
 frdof=temp
 DEALLOCATE(temp)
 !
 RETURN
END SUBROUTINE boundary_cond