SUBROUTINE calc_dof(nodes,dof,disp)
!
! This subroutine calculates the number of DOFs and initiates displacement vector
!
 IMPLICIT NONE
 INTEGER,PARAMETER::iwp=SELECTED_REAL_KIND(15)
 REAL(iwp),INTENT(INOUT)::nodes(:,:)
 REAL(iwp),ALLOCATABLE,INTENT(OUT)::disp(:,:)
 INTEGER,INTENT(OUT)::dof
 INTEGER::i,hvct,brct,bmct,hvdof,brdof,bmdof
 !
 hvct=0
 brct=0
 bmct=0
 !
 DO i=1,SIZE(nodes,1)
	IF (nodes(i,2)/=0) THEN
		hvct=hvct+1
	END IF
	IF (nodes(i,4)/=0) THEN
		brct=brct+1
	END IF
	IF (nodes(i,12)/=0) THEN
		bmct=bmct+1
	END IF
 END DO
 !
 hvdof=2*hvct
 brdof=8*brct
 bmdof=24*bmct
 !
 IF (hvdof>0) THEN
	CALL heavi_nodes(nodes,gpsi)
 END IF
 IF (brdof>0) THEN
	CALL branch_nodes(frt,nodes,gphi,xyz)
 END IF
 IF (bmdof>0) THEN
	CALL bimaterial_nodes(lxe,frt,prop,nodes,gphi,xyz)
 END IF
 !
 dof=2*MAXVAL(MAXVAL(nodes,1))  
 ALLOCATE(disp(dof,1))
 disp=0
 !
 RETURN
END SUBROUTINE calc_dof