SUBROUTINE coord_connec(width,height,frx1,frx2,fry1,fry2,nxe,nye,&
						lxe,lye,frt,nodes,connec,xyz)
!
! This subroutine forms the coordinates and connectivity for a
! rectangular mesh of 4-node quadrilateral elements. 
!
 IMPLICIT NONE
 INTEGER,PARAMETER::iwp=SELECTED_REAL_KIND(15)
 REAL(iwp),INTENT(IN)::width,height,frx1,frx2,fry1,fry2
 REAL(iwp),INTENT(OUT)::lxe,lye
 REAL(iwp),INTENT(OUT)::nodes(:,:),xyz(:,:),frt(:,:)
 INTEGER,INTENT(IN)::nxe,nye
 INTEGER,INTENT(OUT)::connec(:,:)
 INTEGER::ncounter,ecounter,ixnd,iynd,ixem,iyem
 INTEGER,ALLOCATABLE::gnn(:,:)
 !
 lxe=width/nxe
 lye=height/nye
 !
 ALLOCATE(gnn(nxe+1,nye+1))
 gnn=0
 !
 nodes=0
 ncounter=1
 DO iynd=1,nye+1
	DO ixnd=1,nxe+1
		gnn(ixnd,iynd)=ncounter
		xyz(ncounter,1)=ncounter
		xyz(ncounter,2)=(ixnd-1)*lxe
		xyz(ncounter,3)=(iynd-1)*lye
		nodes(ncounter,1)=ncounter
		ncounter=ncounter+1
    END DO
 END DO                                             !!! why iynd and ixnd go to 21?
 !
 ecounter=1
 DO iyem=1,nye
	DO ixem=1,nxe
		connec(ecounter,:)=(/ecounter,gnn(ixem,iyem),gnn(ixem+1,iyem),&
                             gnn(ixem+1,iyem+1),gnn(ixem,iyem+1)/)
		ecounter=ecounter+1
	END DO
 END DO
 !
 frt(1,:)=(/frx1,fry1/)
 frt(2,:)=(/frx2,fry2/)
 !
 RETURN
END SUBROUTINE coord_connec