SUBROUTINE enriched_elem(ii,phdof,connec,nodes,enrelem,iielem)
!
! This subroutine finds the enriched elements.
!
 IMPLICIT NONE
 INTEGER,PARAMETER::iwp=SELECTED_REAL_KIND(15)
 REAL(iwp),INTENT(IN)::nodes(:,:),phdof(:)
 REAL(iwp)::dmin,zero=0.0
 INTEGER,INTENT(IN)::ii,connec(:,:)
 INTEGER,ALLOCATABLE::i(:),ctelem(:),helem(:),c1(:),c2(:),c3(:),c4(:)
 INTEGER,ALLOCATABLE,INTENT(OUT)::enrelem(:),iielem(:)
 CHARACTER(LEN=15)::compa
!
 dmin=zero
 compa='gt'
 CALL find_loc(nodes(:,4),compa,dmin,i)
 CALL intersect_loc(i,connec(:,2),c1)
 CALL intersect_loc(i,connec(:,3),c2)
 CALL intersect_loc(i,connec(:,4),c3)
 CALL intersect_loc(i,connec(:,5),c4)
 CALL unique4(c1,c2,c3,c4,ctelem)
!
 IF (ii==1) THEN
	dmin=zero
	compa='gt'
	CALL find_loc(nodes(:,2),compa,dmin,i)
	CALL intersect_loc(i,connec(:,2),c1)
	CALL intersect_loc(i,connec(:,3),c2)
	CALL intersect_loc(i,connec(:,4),c3)
	CALL intersect_loc(i,connec(:,5),c4)
	CALL unique4(c1,c2,c3,c4,helem) 
	!
	dmin=zero
	compa='gt'
	CALL find_loc(nodes(:,30),compa,dmin,i)
	CALL intersect_loc(i,connec(:,2),c1)
	CALL intersect_loc(i,connec(:,3),c2)
	CALL intersect_loc(i,connec(:,4),c3)
	CALL intersect_loc(i,connec(:,5),c4) 
	CALL unique4(c1,c2,c3,c4,iielem) 
 ELSE
	dmin=phdof(1)/2
	compa='gt'
	CALL find_loc(nodes(:,2),compa,dmin,i)
	CALL intersect_loc(i,connec(:,2),c1)
	CALL intersect_loc(i,connec(:,3),c2)
	CALL intersect_loc(i,connec(:,4),c3)
	CALL intersect_loc(i,connec(:,5),c4)
	CALL unique4(c1,c2,c3,c4,helem) 
	!
	ALLOCATE(iielem(0))
 END IF
 !
 ALLOCATE(enrelem(SIZE(ctelem)+SIZE(helem)))
 enrelem(1:SIZE(ctelem))=ctelem
 enrelem(SIZE(ctelem)+1:SIZE(ctelem)+SIZE(helem))=helem 
 CALL unique1(enrelem)
 !
 RETURN
END SUBROUTINE enriched_elem