SUBROUTINE force_vector(dof,nxe,nye,lxe,lye,bdld,connec,gforce)
!
! This function creates the global force vector 'gforce' from the input file
!
 IMPLICIT NONE
 INTEGER,PARAMETER::iwp=SELECTED_REAL_KIND(15)
 INTEGER,INTENT(IN)::dof,nxe,nye
 REAL(iwp),INTENT(IN)::lxe,lye
 REAL(iwp),ALLOCATABLE,INTENT(IN)::bdld(:)
 INTEGER,ALLOCATABLE,INTENT(IN)::connec(:,:)
 REAL(iwp),ALLOCATABLE,INTENT(OUT)::gforce(:,:)
 INTEGER::i,node
 REAL(iwp)::xforce,yforce
 !
 ALLOCATE(gforce(dof,1))
 gforce=0.0
 xforce=bdld(2)
 yforce=bdld(3)
 !
 IF (bdld(1)==1) THEN
	node=connec((nye-1)*(nxe)+1,5)
	DO i=1,nxe+1
		IF (i==1 .OR. i==nxe+1) THEN
			gforce(2*node-1,1)=lxe*xforce/2.0
			gforce(2*node,1)=lxe*yforce/2.0
		ELSE
			gforce(2*node-1,1)=lxe*xforce
			gforce(2*node,1)=lxe*yforce
		END IF
		node=node+1
	END DO
	node=1
	DO i=1,nxe+1
		IF (i==1 .OR. i==nxe+1) tHEN
			gforce(2*node-1,1)=-lxe*xforce/2.0
			gforce(2*node,1)=-lxe*yforce/2.0
		ELSE
			gforce(2*node-1,1)=-lxe*xforce
			gforce(2*node,1)=-lxe*yforce
		END IF
		node=node+1
	END DO
 ELSE IF (bdld(1)==2) THEN
	node=nxe+1
	DO i=1,nye+1
		IF (i==1 .OR. i==nye+1) THEN
			gforce(2*node-1,1)=lxe*xforce/2.0
			gforce(2*node,1)=lxe*yforce/2.0
		ELSE
			gforce(2*node-1,1)=lxe*xforce
			gforce(2*node,1)=lxe*yforce
		END IF
		node=node+nxe+1
	END DO
	node=1
	DO i=1,nye+1
		IF (i==1 .OR. i==nxe+1) THEN
			gforce(2*node-1,1)=-lxe*xforce/2.0
			gforce(2*node,1)=-lxe*yforce/2.0
		ELSE
			gforce(2*node-1,1)=-lxe*xforce
			gforce(2*node,1)=-lxe*yforce
		END IF
		node=node+nxe+1
	END DO
 ELSE IF (bdld(1)==3) THEN
	node=1
	DO i=1,nxe+1
		IF (i==1 .OR. i==nxe+1) THEN
			gforce(2*node-1,1)=lxe*xforce/2.0
			gforce(2*node,1)=lxe*yforce/2.0
		ELSE
			gforce(2*node-1,1)=lxe*xforce
			gforce(2*node,1)=lxe*yforce
		END IF
		node=node+1
	END DO
 ELSE IF (bdld(1)==4) THEN
	node=1
	DO i=1,nye+1
		IF (i==1 .OR. i==nxe+1) THEN
			gforce(2*node-1,1)=lxe*xforce/2.0
			gforce(2*node,1)=lxe*yforce/2.0
		ELSE
			gforce(2*node-1,1)=lxe*xforce
			gforce(2*node,1)=lxe*yforce
		END IF
		node=node+nxe+1
	END DO
 ELSE
	WRITE(*,*)'error occurs, please modify the input "bdld"'
	STOP
 END IF
 !
 RETURN
END SUBROUTINE force_vector