SUBROUTINE rmv_components(ori,loc,new)
!
! This subroutine removes components located as the array "loc" from the array "ori"
! and automatically reduces the size of the original array resulting the array "new"
!
 IMPLICIT NONE
 INTEGER,PARAMETER::iwp=SELECTED_REAL_KIND(15)
 REAL(iwp),INTENT(IN)::ori(:,:)
 INTEGER,INTENT(IN)::loc(:)
 REAL(iwp),ALLOCATABLE,INTENT(OUT)::new(:,:)
 INTEGER::i,k
 !
 ALLOCATE(new(SIZE(ori,1)-SIZE(loc),SIZE(ori,2)))
 IF (SIZE(new)==0) THEN
	RETURN
 ELSE
	k=1
	DO i=1,SIZE(ori,1)
		IF (ANY(loc/=i)) THEN
			new(k,:)=ori(i,:)
			k=k+1
		END IF
	END DO
 END IF
 !
 RETURN
END SUBROUTINE rmv_components