SUBROUTINE unique4(c1,c2,c3,c4,unqar)
!
! This subroutine uses four different arrays (c1,c2,c3,c4) to find the 
! unique components of all the arrays. The unique components are arranged
! in the unqar array as the result of this subroutine. 
!
 IMPLICIT NONE
 INTEGER,PARAMETER::iwp=SELECTED_REAL_KIND(15)
 INTEGER,INTENT(IN)::c1(:),c2(:),c3(:),c4(:)
 INTEGER,ALLOCATABLE::temp(:)
 INTEGER,DIMENSION(1)::mlc
 INTEGER,ALLOCATABLE,INTENT(OUT)::unqar(:)
 INTEGER::smt,i,k,lcs,numunqar,numtemp,one=1
 !
 ALLOCATE(temp(size(c1)+size(c2)+size(c3)+size(c4)))
 temp(1:size(c1))=c1
 temp(size(c1)+1:size(c1)+size(c2))=c2
 temp(size(c1)+size(c2)+1:size(c1)+size(c2)+size(c3))=c3
 temp(size(c1)+size(c2)+size(c3)+1:size(c1)+size(c2)+size(c3)+size(c4))=c4
 !
 numtemp=SIZE(temp)
 DO i=1,numtemp-1
	smt=MINVAL(temp(i:numtemp))
	mlc=MINLOC(temp(i:numtemp))
	lcs=(i-1)+mlc(1)
	temp(lcs)=temp(i)
	temp(i)=smt
 END DO
 !
 numunqar=SIZE(temp)
 DO i=1,numtemp-1
	IF (temp(i)==temp(i+1)) THEN
		numunqar=numunqar-1
	END IF
 END DO
 ALLOCATE(unqar(numunqar))
 unqar=0
 !
 IF (SIZE(temp)==0) THEN
	RETURN
 END IF
 !
 unqar(one)=temp(one)
 k=2
 DO i=1,numtemp-1
	IF (temp(i)/=temp(i+1)) THEN
		unqar(k)=temp(i+1)
		k=k+1
	END IF
 END DO
 !
 RETURN
END SUBROUTINE unique4